/*****************************************************************************

		Copyright (c) My Company

 Project:  MYPROJ
 FileName: EDWIN.PRO
 Purpose: No description
 Written by: Visual Prolog
 Comments:
******************************************************************************/

include "myproj.inc"
include "myproj.con"
include "hlptopic.con"
facts-editor
      commentflag(window)


%BEGIN_WIN Editor
/**************************************************************************
	Creation and event handling for window: "Editor"
**************************************************************************/

constants

%BEGIN Editor, CreateParms, 11:59:09-12.3.2007, Code automatically updated!
  win_editor_WinType = w_TopLevel
  win_editor_Flags = [wsf_SizeBorder,wsf_TitleBar,wsf_Maximize,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren]
  win_editor_RCT = rct(100,80,440,240)
  win_editor_Menu = res_menu(idr_task_menu)
  win_editor_Title = "Editor"
  win_editor_Help = idh_contents
%END Editor, CreateParms

predicates

  win_editor_eh : EHANDLER

clauses

  win_editor_Create(_Parent):-
ifdef use_editor
	Text = "",
	Font = font_Create(ff_Fixed,[],10),
	ReadOnly = b_false, Indent = b_true, InitPos = 1,
	edit_Create(win_editor_WinType,win_editor_RCT,win_editor_Title,
		 win_editor_Menu,_Parent,win_editor_Flags,Font,ReadOnly,
		 Indent,Text,InitPos,win_editor_eh),
enddef
	true.

%BEGIN Editor, e_Create
  win_editor_eh(_Win,e_Create(_),0):-!,
%BEGIN Editor, InitControls, 11:59:09-12.3.2007, Code automatically updated!
%END Editor, InitControls
%BEGIN Editor, ToolbarCreate, 11:59:09-12.3.2007, Code automatically updated!
%END Editor, ToolbarCreate
	!.
%END Editor, e_Create

%BEGIN Editor, e_Menu, Editor default popup menu 
  win_editor_eh(_Win,e_Menu(ID,_CAS),0):-
	ID >= edit_MenuUndo, ID <= edit_MenuFont, 
	!,fail.
%END Editor, e_Menu, Editor default popup menu
%MARK Editor, new events

%BEGIN Editor, id_file_save
  win_editor_eh(_Win,e_Menu(id_file_save,_ShiftCtlAlt),0):-!,
  Msg="Save As File", 
  Flags=[dlgfn_Save],
  SaveFileName=dlg_GetFileName("*.txt",["*.txt","*.txt","*.*","*.*"],
      Msg, Flags,"", _OutListFiles),
  Text=edit_GetText(_Win),
  file_str(SaveFileName,Text),
  win_SetText(_Win,SaveFileName), 
  !.
%END Editor, id_file_save

%BEGIN Editor, e_LoseFocus
  win_editor_eh(_Win,e_LoseFocus,0):-!,
  menu_Enable(_Win,id_file_save,b_true),
  !.
%END Editor, e_LoseFocus

%BEGIN Editor, e_GetFocus
  win_editor_eh(_Win,e_GetFocus,0):-!,
  menu_Enable(_Win,id_file_save,b_false), 
  !.
%END Editor, e_GetFocus

%BEGIN Editor, e_Char
%  win_editor_eh(_Win,e_Char(_Char,_ShiftCtlAlt),0):-!,
%	!.
  win_editor_eh(_Win,e_Char ('/',_),0):-!,
      not(commentflag(_Win)),
      assert(commentflag(_Win)),
      fail. 
  win_editor_eh(_Win,e_Char ('*',_),0):-!,
      retract(commentflag(_Win)),
      Pos=edit_GetPos(_Win),
      edit_PasteStr(_Win,Pos, "* */"),
      Pos1=Pos+1,
      Pos2=Pos1+4,
      edit_SetSelection(_Win,Pos1,Pos2),
      !.
   win_editor_eh(_Win,e_Char(_,_),0):-!,
       retract(commentflag(_Win)), 
       fail.
%END Editor, e_Char

%BEGIN Editor, e_MouseDbl
  win_editor_eh(_Win,e_MouseDbl(_PNT,_ShiftCtlAlt,_Button),0):-!,
  WordSelected=edit_SelectWord(_Win),
  WordSelected=b_true,
  edit_GetSelection(_Win,Pos1,Pos2),
  Text=edit_GetText(_Win),
  NoOfBytes=Pos2-Pos1,
  substring(Text,Pos1,NoOfBytes,Substring),
  format(Msg,"Got the token: >%<",Substring),
  dlg_Note(Msg),
	!.
%END Editor, e_MouseDbl

%BEGIN Editor, e_Size
  win_editor_eh(_Win,e_Size(_Width,_Height),0):-!,
ifdef use_tbar
	toolbar_Resize(_Win),
enddef
	!.
%END Editor, e_Size

%BEGIN Editor, e_Menu, Parent window 
  win_editor_eh(Win,e_Menu(ID,CAS),0):-!,
	PARENT = win_GetParent(Win),
	win_SendEvent(PARENT,e_Menu(ID,CAS)),
	!.
%END Editor, e_Menu, Parent window

%END_WIN Editor

